------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Table_Models;
with Qt4.Model_Indices;
with Qt4.Sql_Errors;
with Qt4.Sql_Queries;
with Qt4.Sql_Records;
with Qt4.Variants;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Sql_Query_Models is

   type Q_Sql_Query_Model is limited interface
     and Qt4.Abstract_Table_Models.Q_Abstract_Table_Model;

   type Q_Sql_Query_Model_Access is
     access all Q_Sql_Query_Model'Class;
   for Q_Sql_Query_Model_Access'Storage_Size use 0;

   type Q_Sql_Query_Model_Pointer is tagged;

   not overriding
   procedure Clear
    (Self : not null access Q_Sql_Query_Model)
       is abstract;

   not overriding
   function Data
    (Self : not null access constant Q_Sql_Query_Model;
     Item : Qt4.Model_Indices.Q_Model_Index;
     Role : Qt4.Q_Integer
       :=  0)
       return Qt4.Variants.Q_Variant
         is abstract;

   not overriding
   function Header_Data
    (Self : not null access constant Q_Sql_Query_Model;
     Section : Qt4.Q_Integer;
     Orientation : Qt4.Orientation;
     Role : Qt4.Q_Integer
       :=  0)
       return Qt4.Variants.Q_Variant
         is abstract;

   function Last_Error
    (Self : not null access constant Q_Sql_Query_Model'Class)
       return Qt4.Sql_Errors.Q_Sql_Error;

   function Query
    (Self : not null access constant Q_Sql_Query_Model'Class)
       return Qt4.Sql_Queries.Q_Sql_Query;

   function Get_Record
    (Self : not null access constant Q_Sql_Query_Model'Class)
       return Qt4.Sql_Records.Q_Sql_Record;

   function Get_Record
    (Self : not null access constant Q_Sql_Query_Model'Class;
     Row : Qt4.Q_Integer)
       return Qt4.Sql_Records.Q_Sql_Record;

   not overriding
   function Set_Header_Data
    (Self : not null access Q_Sql_Query_Model;
     Section : Qt4.Q_Integer;
     Orientation : Qt4.Orientation;
     Value : Qt4.Variants.Q_Variant;
     Role : Qt4.Q_Integer
       :=  2)
       return Standard.Boolean
         is abstract;

   procedure Set_Query
    (Self : not null access Q_Sql_Query_Model'Class;
     Query : Qt4.Sql_Queries.Q_Sql_Query);

   package Q_Sql_Query_Model_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Sql_Query_Model, Q_Sql_Query_Model_Access);

   type Q_Sql_Query_Model_Pointer is
     new Q_Sql_Query_Model_Pointers.Q_Pointer with null record;

end Qt4.Sql_Query_Models;
